## calligra 2.8.90

=== CMakeLists.txt ===
project(calligra)

cmake_minimum_required(VERSION 2.8.0 FATAL_ERROR)

cmake_policy(SET CMP0002 OLD)
#cmake_policy CMP0017 was introduced in version 2.8.4
if(${CMAKE_VERSION} VERSION_GREATER 2.8.3)
    cmake_policy(SET CMP0017 NEW)
endif()

if(${CMAKE_VERSION} VERSION_GREATER 2.8.12)
    cmake_policy(SET CMP0022 OLD)
endif()

 ######################
#######################
## Constants defines ##
#######################
######################

# define common versions of Calligra applications, used to generate calligraversion.h
# update these version for every release:
set(CALLIGRA_VERSION_STRING "2.9 Beta 1")
set(CALLIGRA_VERSION_MAJOR 2)
set(CALLIGRA_STABLE_VERSION_MINOR 9)
set(CALLIGRA_VERSION_RELEASE 90)  # 89 for Alpha, increase for next test releases, set 0 for first Stable, etc.
#set(CALLIGRA_ALPHA 1) # uncomment only for Pre-Alpha and Alpha
set(CALLIGRA_BETA 1) # uncomment only for Beta
#set(CALLIGRA_RC 1) # uncomment only for RC
set(CALLIGRA_YEAR 2014) # update every year

if(NOT DEFINED CALLIGRA_ALPHA AND NOT DEFINED CALLIGRA_BETA AND NOT DEFINED CALLIGRA_RC)
    set(CALLIGRA_STABLE 1) # do not edit
endif()

message(STATUS "Calligra version: ${CALLIGRA_VERSION_STRING}")

# define the generic version of the Calligra libraries here
# this makes it easy to advance it when the next Calligra release comes
if(CALLIGRA_VERSION_MAJOR EQUAL 2)
    math(EXPR GENERIC_CALLIGRA_LIB_VERSION_MAJOR "${CALLIGRA_STABLE_VERSION_MINOR} + 5")
else()
    # let's make sure we won't forget to update the "5"
    message(FATAL_ERROR "Reminder: please update offset == 5 used to compute GENERIC_CALLIGRA_LIB_VERSION_MAJOR to something bigger")
endif()
set(GENERIC_CALLIGRA_LIB_VERSION "${GENERIC_CALLIGRA_LIB_VERSION_MAJOR}.0.0")
set(GENERIC_CALLIGRA_LIB_SOVERSION "${GENERIC_CALLIGRA_LIB_VERSION_MAJOR}")

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules )

# fetch git revision for the current build

set(CALLIGRA_GIT_SHA1_STRING "")
set(CALLIGRA_GIT_BRANCH_STRING "")

include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)
get_git_branch(GIT_BRANCH)

if(GIT_SHA1 AND GIT_BRANCH)
    string(SUBSTRING ${GIT_SHA1} 0 7 GIT_SHA1)
    set(CALLIGRA_GIT_SHA1_STRING ${GIT_SHA1})
    set(CALLIGRA_GIT_BRANCH_STRING ${GIT_BRANCH})
endif()

if(NOT DEFINED RELEASE_BUILD)
    # estimate mode by CMAKE_BUILD_TYPE content if not set on cmdline
    string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
    set(RELEASE_BUILD_TYPES "release" "relwithdebinfo" "minsizerel")
    list(FIND RELEASE_BUILD_TYPES "${CMAKE_BUILD_TYPE_TOLOWER}" INDEX)
    if (INDEX EQUAL -1)
        set(RELEASE_BUILD FALSE)
    else(INDEX EQUAL -1)
        set(RELEASE_BUILD TRUE)
    endif(INDEX EQUAL -1)
endif(NOT DEFINED RELEASE_BUILD)
message(STATUS "Release build: ${RELEASE_BUILD}")

 ############
#############
## Options ##
#############
############

option(USEOPENGL "Allow the use of OpenGL for Krita" ON)
if (WIN32)
    option(USE_BREAKPAD "Build the crash handler for Krita (only on windows)" OFF)
endif (WIN32)
option(GHNS "support Get Hot New Stuff" OFF)
# TODO: orthogonal setting, results in minimal features, yet needs to be defined
# option(TINY "compile a tiny Calligra" OFF)
option(QT3SUPPORT "Build the parts of Calligra that still depend on Qt3" ON)
option(PACKAGERS_BUILD "Build support of multiple CPU architectures in one binary. Should be used by packagers only." ON)

# TODO: remove option and migration code below before 3.0 release
option(CREATIVEONLY "compile only Karbon and Krita" OFF)

 #######################
########################
## Productset setting ##
########################
#######################

# For predefined productsets see the definitions in CalligraProducts.cmake and
# in the files in the folder cmake/productsets.

# Finding out the products & features to build is done in 5 steps:
# 1. have the user define the products/features wanted, by giving a productset
# 2. estimate all additional required products/features
# 3. estimate which of the products/features can be build by external deps
# 4. find which products/features have been temporarily disabled due to problems
# 5. estimate which of the products/features can be build by internal deps

# get the special macros
include(CalligraProductSetMacros)

# get the definitions of products, features and product sets
include(CalligraProducts.cmake)

set(PRODUCTSET_DEFAULT "ALL")
# temporary migration support
if (CREATIVEONLY)
    set(WARN_ABOUT_CREATIVEONLY TRUE)
    set(PRODUCTSET_DEFAULT "CREATIVE")
endif (CREATIVEONLY)

if(NOT PRODUCTSET)
    set(PRODUCTSET ${PRODUCTSET_DEFAULT} CACHE STRING "Set of products/features to build" FORCE)
endif(NOT PRODUCTSET)

if (RELEASE_BUILD)
    set(CALLIGRA_SHOULD_BUILD_STAGING FALSE)
else (RELEASE_BUILD)
    set(CALLIGRA_SHOULD_BUILD_STAGING TRUE)
endif (RELEASE_BUILD)

# finally choose products/features to build
calligra_set_productset(${PRODUCTSET})

 ########################
#########################
## Look for KDE and Qt ##
#########################
########################
set(KDE_MIN_VERSION "4.3.0")
find_package(KDE4 4.3.0 REQUIRED)

if (QT3SUPPORT)
    find_package(Qt4 4.6.0 REQUIRED QtCore QtGui QtXml QtScript QtSvg QtTest QtWebKit QtDBus Qt3Support)
else (QT3SUPPORT)
    find_package(Qt4 4.6.0 REQUIRED QtCore QtGui QtXml QtScript QtSvg QtTest QtWebKit QtDBus)
endif (QT3SUPPORT)

if (USEOPENGL)
    find_package(Qt4 4.6.0 REQUIRED QtOpenGL)
endif (USEOPENGL)


include (KDE4Defaults)
include (MacroLibrary)
include (MacroAdditionalCleanFiles)
include (MacroAddFileDependencies)

if ((${QTVERSION} VERSION_EQUAL 4.8.0) OR (${QTVERSION} VERSION_EQUAL 4.8.1))
    if (NOT IHAVEPATCHEDQT)
        set(SHOULD_BUILD_PART_WORDS FALSE)
        set(SHOULD_BUILD_PART_STAGE FALSE)
        set(SHOULD_BUILD_PLUGIN_TEXTSHAPE FALSE)
        set(SHOULD_BUILD_PLUGIN_TEXTEDITING FALSE)
        MESSAGE(STATUS "WARNING: You are using a version of Qt that causes crashes. As a result Words and Stage will not be built. Please upgrade to 4.8.2. You can also patch Qt and when building Calligra set IHAVEPATCHEDQT. Patch against Qt can be found in qt48setx.patch")
    endif (NOT IHAVEPATCHEDQT)
endif ((${QTVERSION} VERSION_EQUAL 4.8.0) OR (${QTVERSION} VERSION_EQUAL 4.8.1))

if (GHNS)
    if(NOT ${KDE_VERSION} VERSION_GREATER 4.4.0)
        set(GHNS FALSE)
    endif(NOT ${KDE_VERSION} VERSION_GREATER 4.4.0)

    macro_optional_find_package(LibAttica)
    macro_log_feature(LIBATTICA_FOUND "LibAttica" "Attica is used for Get Hot New Stuff." "https://projects.kde.org/projects/kdesupport/attica" FALSE "" "You need at least version 3.0 for uploading of resources to work.")

    if (NOT LIBATTICA_FOUND)
        set(GHNS FALSE)
    else (NOT LIBATTICA_FOUND)
        MESSAGE(STATUS "WARNING: You are compiling with Get Hot New Stuff enabled. Do not do that when building distribution packages. GHNS is unusable these days until someone starts maintaining it again.")
    endif (NOT LIBATTICA_FOUND)
endif (GHNS)

macro_ensure_out_of_source_build("Compiling Calligra inside the source directory is not possible. Please refer to the build instruction http://community.kde.org/Calligra/Building/Building_Calligra")

if(KDE4_BUILD_TESTS)
    # only with this definition will the FOO_TEST_EXPORT macro do something
    add_definitions(-DCOMPILING_TESTS)
endif(KDE4_BUILD_TESTS)

# overcome some platform incompatibilities
if(WIN32)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/winquirks)
    add_definitions(-D_USE_MATH_DEFINES)
    add_definitions(-DNOMINMAX)
    set(WIN32_PLATFORM_NET_LIBS ws2_32.lib netapi32.lib)
endif(WIN32)

add_definitions(
    -DQT_USE_FAST_CONCATENATION
    -DQT_USE_FAST_OPERATOR_PLUS
)

# would need more code changes before 4.8.0, e.g. with qPrintable()
if(NOT ${QTVERSION} VERSION_LESS 4.8.0)
    # enable QStringBuilder enhancement
    add_definitions(
        -DQT_USE_FAST_CONCATENATION
        -DQT_USE_FAST_OPERATOR_PLUS
    )
endif(NOT ${QTVERSION} VERSION_LESS 4.8.0)


 ###########################
############################
## Required dependencies  ##
############################
###########################

find_package(Perl REQUIRED)
find_package(ZLIB REQUIRED)
find_package(PNG REQUIRED)
if (APPLE)
    # this is not added correctly on OSX -- see http://forum.kde.org/viewtopic.php?f=139&t=101867&p=221242#p221242
    include_directories(${PNG_INCLUDE_DIR})
endif(APPLE)

add_definitions(-DBOOST_ALL_NO_LIB)
find_package(Boost REQUIRED COMPONENTS system) # for pigment and stage
if (NOT Boost_FOUND)
    MESSAGE(FATAL_ERROR "Did not find Boost. Boost is required for the core libraries, stage, sheets and krita.")
endif (NOT Boost_FOUND)

if (APPLE)
   find_package(Carbon REQUIRED)
endif (APPLE)

 ###########################
############################
## Optional dependencies  ##
############################
###########################

##
## Test for sqlite
##
set(SQLITE_MIN_VERSION 3.6.16)
set(SQLITE_RECOMMENDED_VERSION 3.8.6)
set(SQLITE_LOAD_EXTENSION_REQUIRED ON)
macro_optional_find_package(CalligraSqlite ${SQLITE_MIN_VERSION})
macro_bool_to_01(SQLITE_FOUND HAVE_SQLITE)
macro_log_feature(SQLITE_FOUND "SQLite" "Embedded SQL database engine with enabled extensions loading"
                  "http://www.sqlite.org" FALSE "${SQLITE_MIN_VERSION}"
                  "Required by Calligra's default database handler for Kexi and bibliography in Words.")

##
## Test for ICU
##
macro_optional_find_package(ICU)
macro_bool_to_01(ICU_FOUND HAVE_ICU)
macro_log_feature(ICU_FOUND "ICU" "International Components for Unicode (ICU) Library"
                  "http://icu-project.org" FALSE ""
                  "Required by Calligra's default database handler for Kexi and Words.")

##
## Check for OpenEXR
##

macro_optional_find_package(OpenEXR)
macro_bool_to_01(OPENEXR_FOUND HAVE_OPENEXR)

##
## Look for OpenGL
##
set(HAVE_OPENGL 0)
if (USEOPENGL)
    macro_optional_find_package(OpenGL)

    if(OPENGL_FOUND)
        message(STATUS "Found OpenGL: ${OPENGL_LIBRARIES}")
        if(QT_QTOPENGL_FOUND)
            message(STATUS "Found Qt OpenGL support")
            set(HAVE_OPENGL 1)
        else(QT_QTOPENGL_FOUND)
            message(STATUS "Did NOT find Qt OpenGL support. Check your Qt configuration")
        endif(QT_QTOPENGL_FOUND)
    else(OPENGL_FOUND)
        message(STATUS "Did NOT find OpenGL libraries")
    endif(OPENGL_FOUND)
    macro_log_feature(HAVE_OPENGL "OpenGL" "OpenGL support" "" FALSE "" "Required by parts of Krita and optionally by flake")
endif(USEOPENGL)

##
## Test for GNU Scientific Library
##
macro_optional_find_package(GSL)
macro_log_feature(GSL_FOUND "GSL" "GNU Scientific Library" "http://www.gnu.org/software/gsl"
                  FALSE "1.7" "Required by Krita's Transform tool and Sheets' solver plugin")
macro_bool_to_01(GSL_FOUND HAVE_GSL)
configure_file(config-gsl.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-gsl.h )

##
## Test for kdepimlibs
##
macro_optional_find_package(KdepimLibs 4.6.0)
macro_log_feature(KDEPIMLIBS_FOUND "KDE PIMLibs" "KDE Personal Information Management Libraries" "http://www.kde.org/" FALSE "" "Required by Plan and the KDE address book integration (available as a module in KDE)")

##
## Test for eigen3
##
macro_optional_find_package(Eigen3)
macro_log_feature(EIGEN3_FOUND "Eigen" "C++ template library for linear algebra" "http://eigen.tuxfamily.org" FALSE "3.0" "Required by Calligra Sheets and Krita")

##
## Test for QCA2
##
macro_optional_find_package(QCA2)
macro_log_feature(QCA2_FOUND "QCA" "Qt Cryptographic Architecture" "http://delta.affinix.com/qca" FALSE "2.0" "Required for encrypted OpenDocument files and encrypted xls files support (available as a module in kdesupport)")

##
## Test for exiv2
##
set(EXIV2_MIN_VERSION "0.16")
macro_optional_find_package(Exiv2)
macro_log_feature(EXIV2_FOUND "Exiv2" "Image metadata library and tools" "http://www.exiv2.org" FALSE "0.16" "Required by Krita")

##
## Test for soprano
##
macro_optional_find_package(Soprano)

=== 3rdparty/CMakeLists.txt ===
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUC)
    add_definitions(-Wno-unused-variable)
endif (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUC)

if (SHOULD_BUILD_LIB_KDGANTT)
    add_subdirectory(kdgantt)
endif (SHOULD_BUILD_LIB_KDGANTT)

if (SHOULD_BUILD_LIB_KDCHART)
    add_subdirectory(kdchart)
endif (SHOULD_BUILD_LIB_KDCHART)

if (WIN32 AND USE_BREAKPAD)
    add_subdirectory(google-breakpad)
endif (WIN32 AND USE_BREAKPAD)

=== active/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.0)

#cmake_policy CMP0017 was introduced in version 2.8.4
if(${CMAKE_VERSION} VERSION_GREATER 2.8.3)
    cmake_policy(SET CMP0017 NEW)
endif()

project(calligra-active)

find_package(Qt4 4.7.0 REQUIRED)
find_package(KDE4 REQUIRED)

add_definitions(${QT_DEFINITIONS} ${KDE4_DEFINITIONS})
include_directories(${QT_INCLUDES}
                    ${KDE4_INCLUDES}
                    ${KDECLARATIVE_INCLUDE_DIRS}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR})

include_directories(
    ${KORDF_INCLUDES}
    ${CMAKE_SOURCE_DIR}/words/part
    ${CMAKE_SOURCE_DIR}/sheets
    ${CMAKE_SOURCE_DIR}/libs/kopageapp
)

set (calligra-active_RCCS CalligraActive.qrc)
qt4_add_resources(calligra-active_RCC_SRCS ${calligra-active_RCCS})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/calligra_active_global.h.in ${CMAKE_CURRENT_BINARY_DIR}/calligra_active_global.h)

set(calligra-active_SRCS
    src/CACanvasItem.cpp
    src/CAImageProvider.cpp
    src/CAPresentationHandler.cpp
    src/CASpreadsheetHandler.cpp
    src/CATextDocumentHandler.cpp
    src/CAAbstractDocumentHandler.cpp
    src/CADocumentController.cpp
    src/CADocumentInfo.cpp
    src/CAPADocumentModel.cpp
    src/CATextDocumentModel.cpp
    src/CAPAView.cpp
    src/CACanvasController.cpp
    src/MainWindow.cpp
    main.cpp
    ${calligra-active_RCC_SRCS}
)

qt4_automoc(${calligra-active_SRCS})

add_executable(calligraactive ${calligra-active_SRCS})

target_link_libraries(calligraactive
    ${QT_QTDECLARATIVE_LIBRARY}
    ${QT_LIBRARIES}
    ${KDECLARATIVE_LIBRARIES}
    komain
    wordsprivate
    calligrasheetscommon
    kopageapp
    calligrastageprivate
)

if( SHOULD_BUILD_FEATURE_RDF )
    target_link_libraries(calligraactive kordf)
endif( SHOULD_BUILD_FEATURE_RDF )


install(TARGETS calligraactive RUNTIME DESTINATION bin)
install(FILES calligraactive.desktop DESTINATION ${XDG_APPS_INSTALL_DIR}/calligra)
install(DIRECTORY qml DESTINATION share/calligraactive)

=== devtools/CMakeLists.txt ===
if(SHOULD_BUILD_APP_CSTESTER)
    add_subdirectory( cstester )
endif(SHOULD_BUILD_APP_CSTESTER)

if (SHOULD_BUILD_APP_DEVTOOLS)
    add_subdirectory(slidecompare)
    add_subdirectory(scripts)
endif (SHOULD_BUILD_APP_DEVTOOLS)

if (SHOULD_BUILD_BUILDTOOL_RNG2CPP)
    add_subdirectory(rng2cpp)
endif (SHOULD_BUILD_BUILDTOOL_RNG2CPP)

=== doc/CMakeLists.txt ===
add_subdirectory(calligra)
if(SHOULD_BUILD_KEXI)
    add_subdirectory(kexi)
endif(SHOULD_BUILD_KEXI)
if(SHOULD_BUILD_STAGE)
    add_subdirectory(stage)
endif(SHOULD_BUILD_STAGE)
if(SHOULD_BUILD_SHEETS)
    add_subdirectory(sheets)
endif(SHOULD_BUILD_SHEETS)
INSTALL(FILES   calligra.desktop DESTINATION ${XDG_APPS_INSTALL_DIR}/calligra)

=== extras/CMakeLists.txt ===
if(SHOULD_BUILD_APP_CALLIGRA)
  add_subdirectory( calligra )
endif(SHOULD_BUILD_APP_CALLIGRA)

if (SHOULD_BUILD_APP_CONVERTER)
    add_subdirectory( converter )
endif(SHOULD_BUILD_APP_CONVERTER)

if (SHOULD_BUILD_FILEMANAGER_PROPERTIES)
    add_subdirectory( properties )
endif(SHOULD_BUILD_FILEMANAGER_PROPERTIES)

if (SHOULD_BUILD_FILEMANAGER_THUMBNAIL)
    add_subdirectory( thumbnail )
endif(SHOULD_BUILD_FILEMANAGER_THUMBNAIL)

if (SHOULD_BUILD_FILEMANAGER_QUICKPRINT)
    add_subdirectory( quickprint )
endif(SHOULD_BUILD_FILEMANAGER_QUICKPRINT)

if(SHOULD_BUILD_FILEMANAGER_TEMPLATES)
    add_subdirectory( filemanagertemplates )
endif(SHOULD_BUILD_FILEMANAGER_TEMPLATES)

if(SHOULD_BUILD_OKULAR_GENERATOR_ODP)
    add_subdirectory( okularodpgenerator )
endif(SHOULD_BUILD_OKULAR_GENERATOR_ODP)

if(SHOULD_BUILD_OKULAR_GENERATOR_ODT)
    add_subdirectory( okularodtgenerator )
endif(SHOULD_BUILD_OKULAR_GENERATOR_ODT)

=== gemini/CMakeLists.txt ===
project(calligragemini)

if (WIN32)
    option(ENABLE_GEMINI_STARTUP_MAGIC "Enable Gemini's windows startup magic" ON)

    if (ENABLE_GEMINI_STARTUP_MAGIC)
        add_definitions(-DGEMINI_ENABLE_STARTUP_MAGIC)
    endif (ENABLE_GEMINI_STARTUP_MAGIC)
endif (WIN32)

add_definitions(${QT_DEFINITIONS} ${KDE4_DEFINITIONS})

include_directories(${KOMAIN_INCLUDES}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/..
                    ${CMAKE_CURRENT_SOURCE_DIR}/../part
                    #${CMAKE_CURRENT_SOURCE_DIR}/models
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_SOURCE_DIR}/libs/kopageapp
                    ${CMAKE_SOURCE_DIR}/stage
                    ${CMAKE_SOURCE_DIR}/stage/part
                    ${CMAKE_SOURCE_DIR}/words
                    ${CMAKE_SOURCE_DIR}/words/part)

set(calligragemini_SRCS
    main.cpp
    MainWindow.cpp
    desktopviewproxy.cpp
    Constants.cpp
    DocumentListModel.cpp
    DocumentManager.cpp
    ProgressProxy.cpp
    QmlGlobalEngine.cpp
    RecentFileManager.cpp
    Settings.cpp
    SimpleTouchArea.cpp
    TouchDeclarativeView.cpp
    PropertyContainer.cpp
    Theme.cpp
    ToolManager.cpp
    ParagraphStylesModel.cpp
    KeyboardModel.cpp
    ScribbleArea.cpp
    RecentImageImageProvider.cpp
    RecentFilesModel.cpp
    TemplatesModel.cpp
    TemplateVariantsModel.cpp
    CloudAccountsModel.cpp
)

set(thumbnailhelper_SRCS
    thumbnailhelper.cpp
    ThumbnailHelperImpl.cpp
)

if (WIN32)
    set(calligragemini_SRCS ${calligragemini_SRCS} calligrageminiwin.rc)
else (WIN32)
    kde4_add_app_icon(calligragemini_SRCS "${KDE4_ICON_DIR}/oxygen/*/apps/calligragemini.png")
endif (WIN32)

# Thumbnail helper application
# =============================================================================

kde4_add_executable(calligrageminithumbnailhelper ${thumbnailhelper_SRCS})
target_link_libraries(calligrageminithumbnailhelper
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTCORE_LIBRARIES}
    ${QT_LIBRARIES}
    komain
)

# Calligra Gemini application
# =============================================================================

kde4_add_executable(calligragemini ${calligragemini_SRCS})

target_link_libraries(calligragemini
    ${QT_QTDECLARATIVE_LIBRARY}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTOPENGL_LIBRARIES}
    ${QT_LIBRARIES}
    ${GLEW_LIBRARIES}
    komain
    wordsprivate
    calligrastageprivate
)

install(TARGETS   calligragemini calligrageminithumbnailhelper ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS  calligragemini.desktop               DESTINATION ${XDG_APPS_INSTALL_DIR})
#install(FILES     calligrageminirc calligrageminipanelsrc DESTINATION ${CONFIG_INSTALL_DIR} )
install(FILES     calligragemini.qml                   DESTINATION ${DATA_INSTALL_DIR}/calligragemini)
#install(FILES     calligragemini.rc                    DESTINATION ${DATA_INSTALL_DIR}/calligragemini)
install(DIRECTORY qml                                       DESTINATION ${DATA_INSTALL_DIR}/calligragemini)
install(DIRECTORY themes                                    DESTINATION ${DATA_INSTALL_DIR}/calligragemini)

add_subdirectory(pics)
add_subdirectory(cloud)

=== kexi/CMakeLists.txt ===
project(kexi)

INCLUDE(CheckFunctionExists)

SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

option(KEXI_MOBILE "Compile a mobile version of Kexi" OFF)

check_function_exists("uname" HAVE_UNAME)

option(KEXI_DEBUG_GUI "Debugging GUI for Kexi (requires CALLIGRADB_DEBUG_GUI to be set too)" OFF)
option(KEXI_SHOW_UNFINISHED, "Show unfinished features in Kexi. Thus is useful for testing but may confuse end-user." OFF)
option(KEXI_SHOW_UNIMPLEMENTED "Forces to show menu entries and dialogs just to give impression about development plans for Kexi. Only recommended for test/development versions." OFF)

# Experimental:
option(KEXI_SCRIPTS_SUPPORT "Experimental: Enable scripting in Kexi" ON)
option(KEXI_PROJECT_TEMPLATES "Experimental: Enable support for project templates in Kexi" OFF)
option(KEXI_AUTORISE_TABBED_TOOLBAR "Experimental: Autorise the main tabbed toolbar in Kexi" OFF)

ADD_DEFINITIONS(
  -DKEXI_NO_CURSOR_PROPERTY
  -DKEXI_NO_CTXT_HELP
  -DKEXI_NO_SUBFORM
  -DKEXI_NO_QUICK_PRINTING # print/print preview for tables/queries in the navigator
  -DKEXI_NO_AUTOFIELD_WIDGET
)

#no default: add_definitions(-DKDE_DEFAULT_DEBUG_AREA=44010)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config-kexi.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kexi.h )

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${KOMAIN_INCLUDES}
  ${KOPROPERTY_INCLUDES}
  ${CALLIGRADB_INCLUDES}
  ${CMAKE_SOURCE_DIR}/libs
)

IF(KEXI_MOBILE)
ELSE(KEXI_MOBILE)
  add_definitions(-DQT3_SUPPORT -DQT3_SUPPORT_WARNINGS)
ENDIF(KEXI_MOBILE)

add_subdirectory( kexiutils )

macro_optional_find_package(MySQL)
macro_log_feature(MYSQL_FOUND "libmysqlclient" "MySQL Client Library" "http://www.mysql.com" FALSE "" "Required by Kexi MySQL driver")

set (PQXX_MIN_VERSION "3.0.0")
set (PQXX_MAX_VERSION "5.0.0")

macro_optional_find_package(CalligraPostgreSQL)
macro_log_feature(POSTGRESQL_FOUND "libpq" "C application programmer's interface to PostgreSQL" "http://www.postgresql.org" FALSE "" "Required by Kexi PostgreSQL driver")

pkg_check_modules (PQXX libpqxx)

IF (POSTGRESQL_FOUND AND PQXX_FOUND)
   IF (PQXX_VERSION VERSION_GREATER PQXX_MIN_VERSION AND PQXX_VERSION VERSION_LESS PQXX_MAX_VERSION)
      macro_log_feature(PQXX_FOUND "libpqxx" "Official C++ client API for PostgreSQL" "http://pqxx.org/development/libpqxx/" FALSE "" "Required by Kexi PostgreSQL driver")
   ELSE (PQXX_VERSION VERSION_GREATER PQXX_MIN_VERSION AND PQXX_VERSION VERSION_LESS PQXX_MAX_VERSION)
      macro_log_feature(FALSE "libpqxx" "Official C++ client API for PostgreSQL, version >= ${PQXX_MIN_VERSION} and older than ${PQXX_MAX_VERSION}" "http://pqxx.org/development/libpqxx/" FALSE "" "Required by Kexi PostgreSQL driver")
   ENDIF (PQXX_VERSION VERSION_GREATER PQXX_MIN_VERSION AND PQXX_VERSION VERSION_LESS PQXX_MAX_VERSION)
ENDIF (POSTGRESQL_FOUND AND PQXX_FOUND)

macro_optional_find_package(FreeTDS)
macro_log_feature(FREETDS_FOUND "FreeTDS" "Open source implementation of the TDS (Tabular Data Stream) protocol" "http://www.freetds.org" FALSE "" "Required by Kexi Sybase driver")

macro_optional_find_package(XBase)
macro_log_feature(XBASE_FOUND "XBase" "XBase compatible C++ class library" "http://linux.techass.com/projects/xdb" FALSE "" "Required by Kexi XBase driver")

add_subdirectory( kexidb )
add_subdirectory( core )
add_subdirectory( widget )
add_subdirectory( data )
add_subdirectory( pics )
add_subdirectory( plugins )
add_subdirectory( tests )

IF(KEXI_MOBILE)

ELSE(KEXI_MOBILE)
  add_subdirectory( main )
  add_subdirectory( formeditor )
  add_subdirectory( migration )
ENDIF(KEXI_MOBILE)

########### next target ###############

IF(KEXI_MOBILE)
  add_subdirectory( mobile )
ELSE(KEXI_MOBILE)
  set(kexi_SRCS main.cpp )
  kde4_add_app_icon(kexi_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/pics/app/hi*-app-calligrakexi.png")
  kde4_add_executable(kexi ${kexi_SRCS})
  target_link_libraries(kexi
    ${KDE4_KFILE_LIBS}
    ${CALLIGRADB_LIBS}
    keximain
    kexicore
  )
  install(TARGETS kexi ${INSTALL_TARGETS_DEFAULT_ARGS})
ENDIF(KEXI_MOBILE)

########### install files ###############

install(PROGRAMS kexi.desktop DESTINATION ${XDG_APPS_INSTALL_DIR}/calligra)
install(FILES kexi.appdata.xml DESTINATION ${SHARE_INSTALL_PREFIX}/appdata/)

#kde4_create_doxygen_docs( EXCLUDE 3rdparty kexidb/parser/sqlparser.h kexidb/drivers/odbc  )

=== krita/CMakeLists.txt ===
project(krita)

add_definitions(${KDE4_ENABLE_EXCEPTIONS})

# To avoid the confusion of an endless stream of Eigen warnings.
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUC)
    add_definitions(-Wno-unused-local-typedefs)
endif (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUC)


set(KRITA_DEFAULT_TEST_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/sdk/tests/data/)

macro(macro_add_unittest_definitions)
  add_definitions(-DFILES_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data/")
  add_definitions(-DFILES_OUTPUT_DIR="${CMAKE_CURRENT_BINARY_DIR}")
  add_definitions(-DFILES_DEFAULT_DATA_DIR="${KRITA_DEFAULT_TEST_DATA_DIR}")
endmacro()

#
# The reason for this mode is that the Debug mode disable inlining
#
if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS_KRITADEVS "-O3 -g" CACHE STRING "" FORCE)
endif(CMAKE_COMPILER_IS_GNUCXX)

if(MSVC OR (WIN32 AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
    if (USE_BREAKPAD)
        include_directories(${CMAKE_SOURCE_DIR}/3rdparty/google-breakpad/src)
    endif (USE_BREAKPAD)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /STACK:10000000") # for g'mic...
endif(MSVC OR (WIN32 AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel"))

if(NOT WIN32)
    macro_optional_find_package(FFTW3)
    macro_log_feature(FFTW3_FOUND "FFTW3" "A fast, free C FFT library" "http://www.fftw.org/" FALSE "" "Required by the Krita for fast convolution operators")
    macro_bool_to_01(FFTW3_FOUND HAVE_FFTW3)
endif(NOT WIN32)
configure_file(image/config_convolution.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/image/config_convolution.h)

include(CheckFunctionExists)

macro_optional_find_package(GLEW)
macro_bool_to_01(GLEW_FOUND HAVE_GLEW)
configure_file(config-glew.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-glew.h )
macro_log_feature(HAVE_GLEW "GLEW" "The OpenGL Extension Wrangler Library" "http://glew.sourceforge.net" FALSE "" "Required by the Krita shader filter plugin")

if(HAVE_GLEW)
    message(STATUS "GLEW found!")
else(HAVE_GLEW)
    message(STATUS "GLEW NOT found - krita will not be able to use OpenGL.")
endif(HAVE_GLEW)

if(HAVE_OPENGL)
    message(STATUS "OpenGL found -- krita will be able  to use OpenGL for hardware accelerated rendering.")
else(HAVE_OPENGL)
    message(STATUS "OpenGL NOT found - krita will not be able to use OpenGL for hardware accelerated rendering.")
endif(HAVE_OPENGL)

macro_optional_find_package(OCIO)
macro_log_feature(OCIO_FOUND "OCIO" "The OpenColorIO Library" "http://www.opencolorio.org" FALSE "" "Required by the Krita LUT docker")
macro_bool_to_01(OCIO_FOUND HAVE_OCIO)
configure_file(config-ocio.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-ocio.h )

if(UNIX)
    set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES};m")
endif(UNIX)

check_function_exists(powf HAVE_POWF)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config-powf.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-powf.h)

set(LINK_OPENEXR_LIB)
if(OPENEXR_FOUND)
    include_directories(${OPENEXR_INCLUDE_DIR})
    set(LINK_OPENEXR_LIB ${OPENEXR_LIBRARIES})
    add_definitions(${OPENEXR_DEFINITIONS})
endif(OPENEXR_FOUND)

if(WIN32)
    if(MSVC)
        # C4522: 'class' : multiple assignment operators specified
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4522")
    endif(MSVC)
endif(WIN32)

set(KRITA_INCLUDES
    # For config-*.h
    ${CMAKE_CURRENT_BINARY_DIR}

    ${CMAKE_SOURCE_DIR}/krita/image
    ${CMAKE_SOURCE_DIR}/krita/image/brushengine
    ${CMAKE_SOURCE_DIR}/krita/image/tiles
    ${CMAKE_SOURCE_DIR}/krita/libbrush
    ${CMAKE_SOURCE_DIR}/krita/ui
    ${CMAKE_SOURCE_DIR}/krita/ui/canvas
    ${CMAKE_SOURCE_DIR}/krita/ui/tool
    ${CMAKE_SOURCE_DIR}/krita/ui/flake
    ${CMAKE_SOURCE_DIR}/krita/ui/widgets

    # For generated files from .ui
    ${CMAKE_BINARY_DIR}/krita/ui

    ${PIGMENT_INCLUDES}
    ${BASICFLAKES_INCLUDES}
    ${TEXTLAYOUT_INCLUDES}
    ${CMAKE_SOURCE_DIR}/libs/widgets
    ${CMAKE_SOURCE_DIR}/libs/widgets/resources
    ${CMAKE_SOURCE_DIR}/libs/widgets/colorwidgets
    ${CMAKE_SOURCE_DIR}/libs/widgetutils

    ${EIGEN3_INCLUDE_DIR}
    ${Vc_INCLUDE_DIR}

    # 'Export' this for use by filters
    CACHE INTERNAL ""
)

include_directories(${KRITA_INCLUDES})

if(HAVE_OPENGL)
    include_directories(${OPENGL_INCLUDE_DIR})
    if(HAVE_GLEW)
        include_directories(${GLEW_INCLUDE_DIRS})
    endif(HAVE_GLEW)
endif(HAVE_OPENGL)

add_subdirectory( image )
add_subdirectory( libbrush )
add_subdirectory( ui )
add_subdirectory( dtd )
add_subdirectory( plugins )
add_subdirectory( data )
add_subdirectory( pics )

if (WIN32 AND USE_BREAKPAD)
        add_subdirectory( crashreporter )
endif (WIN32 AND USE_BREAKPAD)

if (NOT WIN32)
    add_subdirectory( benchmarks )
endif (NOT WIN32)

set(kritapart_PART_SRCS krita_part_init.cc)
kde4_add_plugin(kritapart ${kritapart_PART_SRCS})
target_link_libraries(kritapart kritaui)
install(TARGETS kritapart DESTINATION ${PLUGIN_INSTALL_DIR})

set(krita_KDEINIT_SRCS main.cc)

if(WIN32 AND USE_BREAKPAD)
    set(krita_KDEINIT_SRCS ${krita_KDEINIT_SRCS} kis_crash_handler.cpp)
    set(BREAKPAD_LIBS breakpad)
endif(WIN32 AND USE_BREAKPAD)

kde4_add_app_icon(krita_KDEINIT_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/pics/app/hi*-app-calligrakrita.png")
kde4_add_kdeinit_executable(krita ${krita_KDEINIT_SRCS})

if (Q_WS_MAC)
    set_target_properties(krita PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.template)
    set_target_properties(krita PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.krita")
    set_target_properties(krita PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "Krita")
endif (Q_WS_MAC)

target_link_libraries(kdeinit_krita kritaui ${BREAKPAD_LIBS})
target_link_libraries(krita kdeinit_krita kritaui)

install(TARGETS krita ${INSTALL_TARGETS_DEFAULT_ARGS})
install(TARGETS kdeinit_krita ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS krita.desktop  DESTINATION ${XDG_APPS_INSTALL_DIR}/calligra)
install(FILES  kritapart.desktop  DESTINATION ${SERVICES_INSTALL_DIR}/calligra)
install(FILES  krita.rc DESTINATION ${DATA_INSTALL_DIR}/krita)
install(FILES  krita.appdata.xml DESTINATION ${SHARE_INSTALL_PREFIX}/appdata/ )

if (${QTVERSION} VERSION_GREATER 4.7.0 AND NOT APPLE AND HAVE_OPENGL)
#    add_subdirectory(sketch)
#    add_subdirectory(gemini)
endif (${QTVERSION} VERSION_GREATER 4.7.0 AND NOT APPLE AND HAVE_OPENGL)

=== libs/CMakeLists.txt ===
if (SHOULD_BUILD_LIB_CALLIGRA)
    add_subdirectory( version )
    add_subdirectory( koplugin )
    add_subdirectory( widgetutils )
    add_subdirectory( widgets )
    add_subdirectory( odf )
    add_subdirectory( textlayout )
    add_subdirectory( kotext )
    add_subdirectory( flake )
    add_subdirectory( basicflakes )
    add_subdirectory( pigment )
    add_subdirectory( main )
    add_subdirectory( kundo2 )
endif (SHOULD_BUILD_LIB_CALLIGRA)

if (SHOULD_BUILD_FEATURE_SCRIPTING)
    add_subdirectory( kokross )
endif (SHOULD_BUILD_FEATURE_SCRIPTING)

if (SHOULD_BUILD_LIB_KOVECTORIMAGE)
    add_subdirectory( vectorimage )
endif (SHOULD_BUILD_LIB_KOVECTORIMAGE)

if (SHOULD_BUILD_LIB_KOPAGEAPP)
    add_subdirectory( kopageapp )
endif (SHOULD_BUILD_LIB_KOPAGEAPP)

if(SHOULD_BUILD_LIB_KOPROPERTY)
    add_subdirectory( koproperty ) # TODO move to independent place like kdesupport
endif(SHOULD_BUILD_LIB_KOPROPERTY)

if (SHOULD_BUILD_LIB_CALLIGRADB)
    add_subdirectory( db ) # used by Kexi and Word's Biblio; TODO: remove when Predicate lib arrives
endif (SHOULD_BUILD_LIB_CALLIGRADB)

# only build koreport if possible
if (SHOULD_BUILD_LIB_KOREPORT)
    add_subdirectory( koreport )
endif (SHOULD_BUILD_LIB_KOREPORT)

if (SHOULD_BUILD_FEATURE_RDF)
    add_subdirectory( rdf )
endif (SHOULD_BUILD_FEATURE_RDF)

=== plan/CMakeLists.txt ===

project(kplato)

# set kplato debug area
add_definitions( -DKDE_DEFAULT_DEBUG_AREA=42000 )

if(KDE4_BUILD_TESTS)
    # only with this definition will the KPLATO_TEST_EXPORT macro do something
    add_definitions(-DCOMPILING_TESTS)
endif(KDE4_BUILD_TESTS)

if (KDEPIMLIBS_FOUND)
    MATH(EXPR KDEPIMLIBS_HEXVERSION "${KDEPIMLIBS_VERSION_MAJOR}*65536 +  ${KDEPIMLIBS_VERSION_MINOR}*256  + ${KDEPIMLIBS_VERSION_PATCH}")
    add_definitions(-DPLAN_KDEPIMLIBS_FOUND -DPLAN_KDEPIMLIBS_HEXVERSION=${KDEPIMLIBS_HEXVERSION})
endif (KDEPIMLIBS_FOUND)

if (PLANCHARTDEBUG)
    add_definitions(-DPLAN_CHART_DEBUG)
endif (PLANCHARTDEBUG)

set( KPLATO_INCLUDES
    ${CMAKE_SOURCE_DIR}/plan/libs/kernel
    ${CMAKE_SOURCE_DIR}/plan/libs/models
    ${CMAKE_BINARY_DIR}/plan/libs/models
    ${CMAKE_SOURCE_DIR}/plan/libs/ui
    ${CMAKE_BINARY_DIR}/plan/libs/ui
    ${CMAKE_BINARY_DIR}/plan

    ${KDGANTT_INCLUDES}
    ${KDCHART_INCLUDES}

    ${KOMAIN_INCLUDES}
    ${KDEPIMLIBS_INCLUDE_DIR}

    ${KOREPORT_INCLUDES}
)

add_subdirectory( libs )

add_subdirectory( templates )
add_subdirectory( pics )
add_subdirectory( toolbar )
add_subdirectory( plugins )
add_subdirectory( tests )

add_subdirectory( workpackage )

include_directories(${KPLATO_INCLUDES})


########### KPlato private library ###############

set(planprivate_LIB_SRCS
    kptviewlistdocker.cpp
    kptviewlist.cpp
    kptviewlistdialog.cpp

    kptschedulesdocker.cpp

    kptconfig.cpp
    kpttaskdefaultpanel.cpp
    kptworkpackageconfigpanel.cpp
    kptcolorsconfigpanel.cpp

    kptcontext.cpp

    kptfactory.cpp
    kptpart.cpp
    kptmaindocument.cpp
    kptview.cpp
#     KPtViewAdaptor.cpp

    kptschedulerpluginloader.cpp
    kptbuiltinschedulerplugin.cpp
    kptconfigskeleton.cpp

    kptinsertfiledlg.cpp

    about/aboutpage.cpp

    KPlatoXmlLoader.cpp
)

kde4_add_ui_files(planprivate_LIB_SRCS
    kptviewlistaddview.ui
    kptviewlisteditview.ui
    kptviewlisteditcategory.ui

    kptconfigtaskpanelbase.ui
    kptworkpackageconfigpanel.ui
    kptcolorsconfigpanel.ui

    kptinsertfilepanel.ui
)

kde4_add_kcfg_files(plansettings_SRCS plansettings.kcfgc)

kde4_add_library(planprivate SHARED ${planprivate_LIB_SRCS} ${libkdgantt_SRCS} ${plansettings_SRCS} )

target_link_libraries(planprivate kplatokernel kplatomodels kplatoui ${KDE4_KHTML_LIBS} ${KDEPIMLIBS_AKONADI_CONTACT_LIBS}  komain)

set_target_properties(planprivate PROPERTIES VERSION ${GENERIC_CALLIGRA_LIB_VERSION} SOVERSION ${GENERIC_CALLIGRA_LIB_SOVERSION} )

install(TARGETS planprivate ${INSTALL_TARGETS_DEFAULT_ARGS})

########### KPlato part ###############

set(planpart_PART_SRCS kptfactoryinit.cpp )

kde4_add_plugin(planpart ${planpart_PART_SRCS})

target_link_libraries(planpart ${KDE4_KPARTS_LIBS} planprivate)

install(TARGETS planpart DESTINATION ${PLUGIN_INSTALL_DIR})


########### KPlato executable ###############

if(NOT RELEASE_BUILD)
    add_definitions(-DMAINTANER_WANTED_SPLASH)
endif(NOT RELEASE_BUILD)

set(calligraplan_KDEINIT_SRCS main.cpp )

kde4_add_app_icon(calligraplan_KDEINIT_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/pics/hi*-app-calligraplan.png")

kde4_add_kdeinit_executable( calligraplan ${calligraplan_KDEINIT_SRCS})

if (Q_WS_MAC)
   set_target_properties(calligraplan PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.template)
   set_target_properties(calligraplan PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.calligra.plan")
   set_target_properties(calligraplan PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "Plan")
endif (Q_WS_MAC)

target_link_libraries(kdeinit_calligraplan komain)

install(TARGETS kdeinit_calligraplan  ${INSTALL_TARGETS_DEFAULT_ARGS})

target_link_libraries(calligraplan kdeinit_calligraplan komain)
install(TARGETS calligraplan  ${INSTALL_TARGETS_DEFAULT_ARGS})

########### install files ###############

install( FILES  planpart.desktop  DESTINATION ${SERVICES_INSTALL_DIR}/calligra)
install( FILES  plan.rc plan_readonly.rc DESTINATION ${DATA_INSTALL_DIR}/plan)
install( PROGRAMS  plan.desktop  DESTINATION ${XDG_APPS_INSTALL_DIR}/calligra)
install( FILES  planrc DESTINATION ${CONFIG_INSTALL_DIR})
install(FILES plansettings.kcfg DESTINATION ${KCFG_INSTALL_DIR})
install( FILES  plan_viewplugin.desktop DESTINATION ${SERVICETYPES_INSTALL_DIR})
install(FILES plan.appdata.xml DESTINATION ${SHARE_INSTALL_PREFIX}/appdata/)

install(FILES
    about/top-left-plan.png
    about/main.html
    about/intro.html
    about/tips.html
    about/tutorial.html
    about/plan.css
    DESTINATION ${DATA_INSTALL_DIR}/plan/about
)

=== plugins/CMakeLists.txt ===
if(MSVC OR (WIN32 AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel"))
  # avoid "cannot open file 'LIBC.lib'" error
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBC.LIB")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:LIBC.LIB")
endif(MSVC OR (WIN32 AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel"))


if (SHOULD_BUILD_PLUGIN_COLORENGINES)
    add_subdirectory( colorengines )
endif (SHOULD_BUILD_PLUGIN_COLORENGINES)

if (SHOULD_BUILD_PLUGIN_MUSICSHAPE)
    add_subdirectory( musicshape )
endif (SHOULD_BUILD_PLUGIN_MUSICSHAPE)

if (SHOULD_BUILD_PLUGIN_SPACENAVIGATOR)
    macro_optional_find_package(Spnav)
    macro_log_feature(SPNAV_FOUND "Spnav" "3Dconnexion device driver and SDK" "http://spacenav.sourceforge.net/" FALSE "" "Required by SpaceNavigator 3D mouse plugin") 
    IF (SPNAV_FOUND)
        add_subdirectory( spacenavigator )
    ENDIF (SPNAV_FOUND)
endif (SHOULD_BUILD_PLUGIN_SPACENAVIGATOR)

if (SHOULD_BUILD_PLUGIN_ARTISTICTEXTSHAPE)
    add_subdirectory( artistictextshape )
endif (SHOULD_BUILD_PLUGIN_ARTISTICTEXTSHAPE)

if (SHOULD_BUILD_PLUGIN_DOCKERS)
    add_subdirectory( dockers )
endif (SHOULD_BUILD_PLUGIN_DOCKERS)

if (SHOULD_BUILD_PLUGIN_TEXTEDITING)
    add_subdirectory( textediting )
endif(SHOULD_BUILD_PLUGIN_TEXTEDITING)

add_subdirectory( kexi )

if (SHOULD_BUILD_PLUGIN_DEFAULTTOOLS)
    add_subdirectory( defaultTools )
endif (SHOULD_BUILD_PLUGIN_DEFAULTTOOLS)

if (SHOULD_BUILD_PLUGIN_PATHSHAPES)
    add_subdirectory( pathshapes )
endif (SHOULD_BUILD_PLUGIN_PATHSHAPES)

if (SHOULD_BUILD_PLUGIN_VARIABLES)
    add_subdirectory( variables )
endif (SHOULD_BUILD_PLUGIN_VARIABLES)

if (SHOULD_BUILD_PLUGIN_CHARTSHAPE)
    add_subdirectory( chartshape )
endif (SHOULD_BUILD_PLUGIN_CHARTSHAPE)

if (SHOULD_BUILD_PLUGIN_PICTURESHAPE)
    add_subdirectory( pictureshape )
endif (SHOULD_BUILD_PLUGIN_PICTURESHAPE)

if (SHOULD_BUILD_PLUGIN_TEXTSHAPE)
    add_subdirectory( textshape )
endif(SHOULD_BUILD_PLUGIN_TEXTSHAPE)

if (SHOULD_BUILD_PLUGIN_PLUGINSHAPE)
    add_subdirectory( pluginshape )
endif (SHOULD_BUILD_PLUGIN_PLUGINSHAPE)

if (SHOULD_BUILD_PLUGIN_FORMULASHAPE)
    add_subdirectory( formulashape )
endif (SHOULD_BUILD_PLUGIN_FORMULASHAPE)

if (SHOULD_BUILD_PLUGIN_VECTORSHAPE)
    # ??? old comment: as the vector shape depends on filters subdir (not really intuitive) lets allow disabling
    add_subdirectory( vectorshape )
endif (SHOULD_BUILD_PLUGIN_VECTORSHAPE)

if (SHOULD_BUILD_PLUGIN_VIDEOSHAPE)
    add_subdirectory( videoshape )
endif (SHOULD_BUILD_PLUGIN_VIDEOSHAPE)

# only build the reporting plugins if building koreport
if(SHOULD_BUILD_PLUGIN_REPORTING)
    add_subdirectory( reporting )
endif(SHOULD_BUILD_PLUGIN_REPORTING)

if(SHOULD_BUILD_PLUGIN_SEMANTICITEMS)
    add_subdirectory( semanticitems )
endif(SHOULD_BUILD_PLUGIN_SEMANTICITEMS)

#add_subdirectory( videoshape )
#add_subdirectory( commentshape )

add_subdirectory( staging )

=== debian/changelog ===
calligra (1:2.8.90-0ubuntu5) vivid; urgency=medium

  * Yet another addition to kubuntu_armhf.diff

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 14 Jan 2015 13:53:38 +0100

calligra (1:2.8.90-0ubuntu4) vivid; urgency=medium

  * Another fix in kubuntu_armhf.diff

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 14 Jan 2015 12:48:06 +0100

calligra (1:2.8.90-0ubuntu3) vivid; urgency=medium

  * Further fixes in kubuntu_armhf.diff

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 14 Jan 2015 11:48:58 +0100

calligra (1:2.8.90-0ubuntu2) vivid; urgency=medium

  * Add kubuntu_armhf.diff to hopefully fix compile failure no armhf

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 14 Jan 2015 10:30:56 +0100

calligra (1:2.8.90-0ubuntu1) vivid; urgency=medium

  * New upstream release
  * New package calligragemini to replace kritagemini
  * Build-dep on libeigen3-dev

 -- Sergey Popov <sergobot256@gmail.com>  Thu, 18 Dec 2014 18:29:53 +0300 

=== debian/control ===
Source: calligra
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adrien Grellier <adrien.grellier@laposte.net>,
           Raúl Sánchez Siles <rasasi78@gmail.com>
Build-Depends: cauchy-dev,
               cmake (>= 2.6.2),
               debhelper (>= 9),
               freetds-dev,
               kdelibs5-dev (>= 4:4.4.0),
               kdepimlibs5-dev (>= 4:4.4.3),
               libattica-dev,
               libboost-dev,
               libboost-system1.55-dev,
               libeigen3-dev,
               libetonyek-dev,
               libexiv2-dev,
               libfftw3-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libglew-dev [!armel !armhf !arm64],
               libglib2.0-dev,
               libgsl0-dev,
               libicu-dev,
               libjpeg-dev,
               libkactivities-dev,
               libkdcraw-dev (>= 4:4.4.3),
               liblcms2-dev,
               libmarble-dev (>> 4:4.8),
               libmysqlclient-dev,
               libodfgen-dev,
               libopencolorio-dev [!armhf],
               libopenexr-dev,
               libopenjpeg-dev,
               libphononexperimental-dev,
               libpng-dev,
               libpoppler-private-dev,
               libpoppler-qt4-dev,
               libpq-dev,
               libpqxx3-dev,
               libqca2-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               libqtwebkit-dev,
               libsoprano-dev,
               libspnav-dev,
               libsqlite3-dev,
               libtiff-dev,
               libvisio-dev,
               libwpd-dev (>= 0.9.1),
               libwpg-dev (>= 0.2.0),
               libwps-dev,
               libxbase64-dev,
               libxi-dev,
               okular-dev (>= 4:4.12.90),
               pkg-kde-tools (>= 0.9),
               pstoedit,
               shared-desktop-ontologies,
               shared-mime-info,
               vc-dev [!powerpc !armhf !arm64 !ppc64el],
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://www.calligra-suite.org/
Vcs-Browser: http://bazaar.launchpad.net/~kubuntu-packagers/kubuntu-packaging/calligra
Vcs-Bzr: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/calligra
X-Debian-Vcs-Git: git://git.debian.org/pkg-kde/kde-std/calligra.git
X-Debian-Vcs-Browser: http://git.debian.org/?p=pkg-kde/kde-std/calligra.git

Package: calligra
Architecture: all
Depends: braindump (>= ${source:Version}),
         calligraauthor (>= ${source:Version}),
         calligraflow (>= ${source:Version}),
         calligraplan (>= ${source:Version}),
         calligrasheets (>= ${source:Version}),
         calligrastage (>= ${source:Version}),
         calligrawords (>= ${source:Version}),
         karbon (>= ${source:Version}),
         kexi (>= ${source:Version}),
         krita (>= ${source:Version}),
         ${misc:Depends}
Homepage: http://www.calligra-suite.org
Description: extensive productivity and creative suite
 Calligra Suite is a set of applications written to help you to accomplish
 your work. It includes office applications such as a word processor,
 a spreadsheet, a presentation program, a database application, etc., and
 raster and vector graphics tools.
 .
 This metapackage provides all the components of the Calligra Suite.

Package: karbon
Architecture: any
Section: graphics
Depends: calligra-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: pstoedit
Breaks: calligra-data (<< 1:2.6.4-0ubuntu1), koffice-data (<< 1:2.4)
Replaces: calligra-data (<< 1:2.6.4-0ubuntu1), koffice-data (<< 1:2.4)
Homepage: http://www.calligra-suite.org/karbon/
Description: vector graphics application for the Calligra Suite
 Karbon is a vector drawing application with an user interface that is easy to
 use, highly customizable and extensible. That makes Karbon a great application
 for users starting to explore the world of vector graphics as well as for
 artists wanting to create breathtaking vector art. Features include:
 .
  * Loading support for ODG, SVG, WMF, WPG, EPS/PS
  * Writing support for ODG, SVG, WMF, PNG, PDF
  * Customizable user interface with freely placeable toolbars and dockers
  * Layer docker for easy handling of complex documents including preview
    thumbnails, support for grouping shapes via drag and drop,
    controlling visibility of shapes or locking
  * Advanced path editing tool with great on-canvas editing capabilities
  * Various drawing tools for creating path shapes including a draw path
    tool and a pencil tool, as well as a calligraphy drawing tool
  * Gradient and pattern tools for easy on-canvas editing of gradient and
    pattern styles
  * Top notch snapping facilities for guided drawing and editing (e.g.
    snapping to grid, guide lines, path nodes, bounding boxes, orthogonal
    positions, intersections of path shapes or extensions of lines and
    paths)
  * Many predefined basic shapes included, such as circle/ellipse, star or
    rectangle
  * Artistic text shape with support for following path outlines
    (i.e. text on path)
  * Complex path operations and effects like Boolean set operations,
    path flattening, rounding and refining as well as whirl/pinch effects
  * Extensible by writing plugins for new tools, shapes and dockers
 .
 This package is part of the Calligra Suite.

Package: kexi
Architecture: any
Section: database
Depends: calligra-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: kexi-calligrasheets-driver,
          kexi-mysql-driver,
          kexi-postgresql-driver,
          kexi-sybase-driver,
          kexi-xbase-driver
Replaces: koffice-doc-html
Conflicts: koffice-doc-html
Homepage: http://www.calligra-suite.org/kexi/
Description: integrated database environment for the Calligra Suite
 Kexi is an integrated data management application. It can be used for
 creating database schemas, inserting data, performing queries, and
 processing data. Forms can be created to provide a custom interface to
 your data. All database objects - tables, queries and forms - are stored
 in the database, making it easy to share data and design.
 .
 Kexi is considered as a long awaited Open Source competitor for MS Access,
 Filemaker and Oracle Forms. Its development is motivated by the lack of
 Rapid Application Development (RAD) tools for database systems that are
 sufficiently powerful, inexpensive, open standards driven and portable
 across many operating systems and hardware platforms.
 .
 This package is part of the Calligra Suite.

Package: kexi-calligrasheets-driver
Architecture: any
Depends: calligrasheets (= ${binary:Version}),
         kexi (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Tables plugin for kexi
 Kexi is an integrated data management application. It can be used for
 creating database schemas, inserting data, performing queries, and
 processing data. Forms can be created to provide a custom interface to
 your data. All database objects - tables, queries and forms - are stored
 in the database, making it easy to share data and design.
 .
 This package provides support for Calligra Tables in Kexi.
 .
 This package is part of the Calligra Suite.

Package: kexi-mysql-driver
Architecture: any
Section: database
Depends: kexi (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: kexi (<< 1:2.3.70)
Replaces: kexi (<< 1:2.3.70)
Description: MySQL support for kexi
 Kexi is an integrated data management application. It can be used for
 creating database schemas, inserting data, performing queries, and
 processing data. Forms can be created to provide a custom interface to
 your data. All database objects - tables, queries and forms - are stored
 in the database, making it easy to share data and design.
 .
 This package provides support for MySQL in Kexi.
 .
 This package is part of the Calligra Suite.

Package: kexi-postgresql-driver
Architecture: any
Section: database
Depends: kexi (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: kexi (<< 1:2.3.70)
Replaces: kexi (<< 1:2.3.70)
Description: PostgreSQL support for kexi
 Kexi is an integrated data management application. It can be used for
 creating database schemas, inserting data, performing queries, and
 processing data. Forms can be created to provide a custom interface to
 your data. All database objects - tables, queries and forms - are stored
 in the database, making it easy to share data and design.
 .
 This package provides support for PostgreSQL in Kexi.
 .
 This package is part of the Calligra Suite.

Package: kexi-xbase-driver
Architecture: any
Section: database
Depends: kexi (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: kexi (<< 1:2.3.70)
Replaces: kexi (<< 1:2.3.70)
Description: XBase support for kexi
 Kexi is an integrated data management application. It can be used for
 creating database schemas, inserting data, performing queries, and
 processing data. Forms can be created to provide a custom interface to
 your data. All database objects - tables, queries and forms - are stored
 in the database, making it easy to share data and design.
 .
 This package provides support for XBase in Kexi.
 .
 This package is part of the Calligra Suite.

Package: kexi-sybase-driver
Architecture: any
Section: database
Depends: kexi (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: kexi (<< 1:2.3.70)
Replaces: kexi (<< 1:2.3.70)
Description: Sybase support for kexi
 Kexi is an integrated data management application. It can be used for
 creating database schemas, inserting data, performing queries, and
 processing data. Forms can be created to provide a custom interface to
 your data. All database objects - tables, queries and forms - are stored
 in the database, making it easy to share data and design.
 .
 This package provides support for Sybase in Kexi.
 .
 This package is part of the Calligra Suite.

Package: kexi-web-form-widget
Architecture: any
Section: database
Depends: kexi (>= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: kexi (<< 1:2.3.70)
Replaces: kexi (<< 1:2.3.70)
Description: web form widget for Kexi
 Kexi is an integrated data management application. It can be used for
 creating database schemas, inserting data, performing queries, and
 processing data. Forms can be created to provide a custom interface to
 your data. All database objects - tables, queries and forms - are stored
 in the database, making it easy to share data and design.
 .
 This package provides a web widget for Kexi using QtWebKit.
 .
 This package is part of the Calligra Suite.

Package: kexi-map-form-widget
Architecture: any
Section: database
Depends: kexi (>= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: kexi (<< 1:2.3.70)
Replaces: kexi (<< 1:2.3.70)
Description: map form widget for Kexi
 Kexi is an integrated data management application. It can be used for
 creating database schemas, inserting data, performing queries, and
 processing data. Forms can be created to provide a custom interface to
 your data. All database objects - tables, queries and forms - are stored
 in the database, making it easy to share data and design.
 .
 This package provides a map widget for Kexi using the Marble library.
 .
 This package is part of the Calligra Suite.

Package: calligra-reports-web-element
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: web element for Calligra Reports
 Calligra Suite is a set of applications written to help you to accomplish
 your work. It includes office applications such as a word processor,
 a spreadsheet, a presentation program, a database application, etc., and
 raster and vector graphics tools.
 .
